/* freier Plattenspeicher ... */
#include <dos.h>  /* needed for _dos_getdiskfree and diskfree_t */

main(int argc, char *argv[])
{
    long     bytes_avail;
    long     bytes_used;
    long     total_bytes;
    unsigned drive=0;
    unsigned kurz=0;

    struct diskfree_t disk;

    if (argc >= 3) kurz=1;

    if (argc >= 2)
       drive = toupper(argv[1][0]) - 'A' + 1;
    else
      _dos_getdrive(&drive);

    _dos_getdiskfree(drive, &disk);

    total_bytes = (long) disk.total_clusters *
		  (long) disk.sectors_per_cluster *
		  (long) disk.bytes_per_sector;
	
    bytes_avail = (long) disk.avail_clusters *
		  (long) disk.sectors_per_cluster *
		  (long) disk.bytes_per_sector;

    bytes_used = total_bytes - bytes_avail;

    if (! kurz) {
       printf("Laufwerk ..............: %c:\n",       'A' + drive - 1);
       printf("Gesamtplattenspeicher .: %7.3f MBytes\n", (float) total_bytes/1024/1024);
       printf("davon benutzt .........: %7.3f MBytes\n", (float) bytes_used /1024/1024);
       printf("noch verfgbar ........: %7.3f MBytes\n", (float) bytes_avail/1024/1024);
   }
   else
       printf("noch verfgbar auf Laufwerk %c:    [%ld]\n",       'A' + drive - 1, bytes_avail);

}
