// SBT, Heiko Thimm
// Ausgabeprogramm, mglichst einfach
// Version 02

// Steuerung ber Parameter

// 1 Parameter    -> Dateiname
// 2 Parameter    -> Seitenlnge
// 3 Parameter    -> Pause N/Y

#include <string.h>
#include <stdlib.h>
#include <conio.h>
#include <fstream.h>
#include <math.h>      // needed for atoi

main (int argc, char *argv[])
{
   if (argc != 4)      // test number of arguments
   {
      cerr << "Aufruf: <Datei> <Seitenlnge> <Monitor Y/N> \n\n";
      return 1;
   }
   ifstream fin(argv[1]);
   if (fin.fail())
   {
      cerr << "Datei " << argv[1] << " konnte nicht geffnet werden. \n\n";
      return 1;
   }
   char ch;
   char isMonitor  = (strcmp(strupr(argv[3]),"N") != 0);
   char isBreak    = 0;
   char lastkey    = 0;
   int  linecount  = 0;
   int  pagecount  = 1;
   int  pagelength = atoi(argv[2]);
   int  charcount  = 0;

   if (! isMonitor)
   {
      cerr << "\n";
      cerr << "Ausgabe luft ... Abbruch mit ^C\n";
      cerr << "[" << pagecount << "]";
   }

   while ( (fin.get(ch))  && (! isBreak))
   {
      charcount += 1;
      switch (ch)
      {
         case '\014': linecount = 0;  // ff
                      pagecount += 1;
                      if (isMonitor)
                      {
                        cout <<'\012';
                        lastkey = getch();
                        if ( (lastkey=='\033') || (lastkey=='\003') )   // ESC oder ^C
                           isBreak = 1;
                      }
                      else
                      {
                         cout << '\014';
                         cerr << " [" << pagecount << "]";
                      }
                      break;

         case '\012': linecount += 1; // lf
                      if (linecount >= pagelength)
                      {
                         linecount = 0;
                         pagecount += 1;
                         if (isMonitor)
                         {
                           cout <<'\012';
                           lastkey = getch();
                           if ( (lastkey=='\033') || (lastkey=='\003') )   // ESC oder ^C
                              isBreak = 1;
                         }
                         else
                         {
                           cerr << " [" << pagecount << "]";
                           cout <<'\012'<< '\014';
                         }
                      }
                      else
                         cout <<'\012';
                      break;
         case '\015':            // cr
         default    : cout << ch;
      }
   }
   if (charcount > 0)
      if (isMonitor)
      {
        if  (! isBreak)
        {
           cout <<'\012';
           getch();
        }
        else
           cout <<"**** Abbruch ****\n";
      }
      else
         cout << '\014';

   fin.close();
   return 0;

}
