@ECHO OFF
CLS

REM -------------------------------------------------------------------
REM ! Kopieren Datensicherungsdatei                                   !
REM !                                                                 !
REM ! Autor      : Heiko Thimm                                        !
REM ! Datum      : 20-09-2005                                         !
REM ! Version    : 01                                                 !
REM -------------------------------------------------------------------

REM berprfung der Parameter
REM -------------------------
REM Parameter  Beschreibung
REM
REM    1       Datei
REM    2       Programmpfad Utilities, leer oder mu mit "\" enden
REM
IF "%1" == ""  GOTO ERR_PARA

CLS
ECHO Ŀ
ECHO DATENSICHERUNG                                    GENprofi GPFAM
ECHO Ĵ
ECHO Die Sicherung ist erfolgt. Sie knnen nun die Sicherungsdatei   
ECHO auf ein Sicherungsmedium kopieren.                              
ECHO 
ECHO Sicherungsdatei    : %1
ECHO Ŀ
ECHO Kopie auf Laufwerk : [ABCDEFGHIJKLMNOPQRSTUVWXYZ]               
ECHO                      [Leertaste oder ESC]                       
ECHO 
ECHO 
%2SBTKEY

IF ERRORLEVEL 123 GOTO ENDE
IF ERRORLEVEL 122 GOTO LWZ
IF ERRORLEVEL 121 GOTO LWY
IF ERRORLEVEL 120 GOTO LWX
IF ERRORLEVEL 119 GOTO LWW
IF ERRORLEVEL 118 GOTO LWV
IF ERRORLEVEL 117 GOTO LWU
IF ERRORLEVEL 116 GOTO LWT
IF ERRORLEVEL 115 GOTO LWS
IF ERRORLEVEL 114 GOTO LWR
IF ERRORLEVEL 113 GOTO LWQ
IF ERRORLEVEL 112 GOTO LWP
IF ERRORLEVEL 111 GOTO LWO
IF ERRORLEVEL 110 GOTO LWN
IF ERRORLEVEL 109 GOTO LWM
IF ERRORLEVEL 108 GOTO LWL
IF ERRORLEVEL 107 GOTO LWK
IF ERRORLEVEL 106 GOTO LWJ
IF ERRORLEVEL 105 GOTO LWI
IF ERRORLEVEL 104 GOTO LWH
IF ERRORLEVEL 103 GOTO LWG
IF ERRORLEVEL 102 GOTO LWF
IF ERRORLEVEL 101 GOTO LWE
IF ERRORLEVEL 100 GOTO LWD
IF ERRORLEVEL 99  GOTO LWC
IF ERRORLEVEL 98  GOTO LWB
IF ERRORLEVEL 97  GOTO LWA
IF ERRORLEVEL 91  GOTO ENDE
IF ERRORLEVEL 90  GOTO LWZ
IF ERRORLEVEL 89  GOTO LWY
IF ERRORLEVEL 88  GOTO LWX
IF ERRORLEVEL 87  GOTO LWW
IF ERRORLEVEL 86  GOTO LWV
IF ERRORLEVEL 85  GOTO LWU
IF ERRORLEVEL 84  GOTO LWT
IF ERRORLEVEL 83  GOTO LWS
IF ERRORLEVEL 82  GOTO LWR
IF ERRORLEVEL 81  GOTO LWQ
IF ERRORLEVEL 80  GOTO LWP
IF ERRORLEVEL 79  GOTO LWO
IF ERRORLEVEL 78  GOTO LWN
IF ERRORLEVEL 77  GOTO LWM
IF ERRORLEVEL 76  GOTO LWL
IF ERRORLEVEL 75  GOTO LWK
IF ERRORLEVEL 74  GOTO LWJ
IF ERRORLEVEL 73  GOTO LWI
IF ERRORLEVEL 72  GOTO LWH
IF ERRORLEVEL 71  GOTO LWG
IF ERRORLEVEL 70  GOTO LWF
IF ERRORLEVEL 69  GOTO LWE
IF ERRORLEVEL 68  GOTO LWD
IF ERRORLEVEL 67  GOTO LWC
IF ERRORLEVEL 66  GOTO LWB
IF ERRORLEVEL 65  GOTO LWA

IF ERRORLEVEL 32 GOTO ENDE
IF ERRORLEVEL 27 GOTO ENDE
GOTO ENDE

:LWZ
xcopy %1 z:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWY
xcopy %1  Y:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWX
xcopy %1  X:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWW
xcopy %1  W:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWV
xcopy %1  V:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWU
xcopy %1  U:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWT
xcopy %1  T:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWS
xcopy %1  S:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWR
xcopy %1  R:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWQ
xcopy %1  Q:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWP
xcopy %1  P:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWO
xcopy %1  O:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWN
xcopy %1  N:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWM
xcopy %1  M:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWL
xcopy %1  L:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWK
xcopy %1  K:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWJ
xcopy %1  J:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWI
xcopy %1  I:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWH
xcopy %1  H:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWG
xcopy %1  G:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWF
xcopy %1  F:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWE
xcopy %1  E:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWD
xcopy %1  D:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWC
xcopy %1  C:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWB
xcopy %1  B:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE

:LWA
xcopy %1  A:\ /V /Y > NUL
IF ERRORLEVEL 1 GOTO ERR_COPY
GOTO ENDE



:ERR_COPY
REM -------------------------------------------------------------------
REM                                             Datensicherungsfehler !
REM -------------------------------------------------------------------
REM Bildschirm wird vor der Anzeige nicht gelscht, damit
REM die eventuellen Fehlermeldungen erhalten bleiben !
REM -------------------------------------------------------------------
ECHO Ŀ
ECHO DATENSICHERUNG        *** FEHLER ***              GENprofi GPFAM
ECHO Ĵ
ECHO                                                                 
ECHO Beim Kopieren der Sicherungsdatei ist ein Fehler aufgetreten!   
ECHO                                                                 
ECHO Die im Verzeichnis backup enthaltene Sicherungsdatei ist        
ECHO manuell zu kopieren!                                            
ECHO Ĵ
ECHO Weiter mit Tastendruck ...                                      
ECHO 
ECHO 
PAUSE > NUL
GOTO ENDE

:ERR_PARA
REM -------------------------------------------------------------------
REM                                                   Parameterfehler !
REM -------------------------------------------------------------------
CLS
ECHO Ŀ
ECHO DATENSICHERUNG        *** FEHLER ***              GENprofi GPFAM
ECHO Ĵ
ECHO                                                                 
ECHO Die Kopierroutine ist falsch aufgerufen worden! berprfen      
ECHO Sie bitte die Installation!                                     
ECHO                                                                 
ECHO            SICHERUNG IST NICHT DURCHGEFHRT WORDEN !            
ECHO Ĵ
ECHO Weiter mit Tastendruck ...                                      
ECHO 
ECHO 
PAUSE > NUL
GOTO ENDE

:ENDE




