// ---------------------------------------------------------------------------
// Programm : GP_AUSW.PRG
// Autor    : Heiko Thimm
// Stand    : 97-10-22
//
//            Programmroutinen zum GP Export Modul
// ---------------------------------------------------------------------------
// <c> 1997, Heiko Thimm
// ------------------------------------------------------------------------------
// Ich habe mich (hoffentlich) weitestgehend bemht, Standard-Clipper
// Code zu schreiben. Dies ist gar nicht so einfach, wenn man sonst auf
// eine Vielzahl von Tools zurckgreift. Dennoch wurde dieser Weg gewhlt,
// da damit eine einfache Ausgangsbasis geschaffen wird, um Programmablufe
// zu dokumentieren.
//
// Den hier vorliegenden Quell-Code haben Sie in Verbindung mit dem
// GENprofi ExportModul erhalten.
//
// Bitte beachten Sie folgende Hinweise :
// --------------------------------------
//
// 1.) Es versteht sich von selbst, da Sie diese Quellen nicht
//     weitergeben oder verffentlichen drfen.
//
// 2.) Sie drfen aber diese Quellen dazu benutzen, um eigene
//     Programme zu schreiben. Die Verwendung meiner Quellen in eigenen
//     Programmen zum eigenen Gebrauch oder bei Weitergabe fr eine
//     Bearbeitungsgebhr sind keine Lizenzabgaben an mich fllig.
//
// 3.) Sofern Sie als Entwickler eigene Programme fr GENprofi entwickeln
//     und meine Quellen verwenden, so mssen Sie auf der/den
//     Programmdisketten folgenden Hinweis anbringen :
//
//        Teile : <c> 1997, Heiko Thimm, Birnbach
//
// ---------------------------------------------------------------------------

#include "std.ch"

// ---------------------------------------------------------------------------
PROCEDURE GP_AUSW(sParaMod, sParaCol)
// ---------------------------------------------------------------------------

   // ------------------------------------------------------------------------
   // Ohne Aufrufparameter geht gar nichts ...
   // ------------------------------------------------------------------------
   IF VALTYPE(sParaMod) != "C"

      TONE(440,4) ; TONE(440,4) ; TONE(440,4)

      ? "***** FEHLER *****"
      ?
      ? "Programmaufruf : GP_AUSW  <MODUL>  [SW Darstellung]"
      ?
      ? "---------------------------------------------------------------"
      ? "Hinweise in der Programmdokumentation zum GENprofi EXPORT Modul"
      ? "---------------------------------------------------------------"
      ? "[Taste ....]"
      INKEY(0)

      prog_ende(.F.)
   ELSE
      sParaMod := UPPER(sParaMod)
   ENDIF

   // ------------------------------------------------------------------------
   set_init()                             // Systemeinstellungen

   IF VALTYPE(sParaCol) == "C"            // Egal welcher Wert, immer SW
      std_color(.F.)
   ELSE
      std_color()                         // Dann erkenne mal schn selber ...
   ENDIF

   hauptmaske("GENPROFI Export                                                     Auswertungen", ;
              "<c> 1997, Heiko Thimm                                                Version : 1")
   // ------------------------------------------------------------------------

   DO CASE
   CASE sParaMod == "NAMEN"
      aw_namen()
   CASE sParaMod == "NOZ"
      aw_noz()
   CASE sParaMod == "OP"
      aw_op()
   CASE sParaMod == "QP"
      aw_qp()
   CASE sParaMod == "ALTPER"
      aw_ap()
   CASE sParaMod == "PL1"
      aw_pl1()
   CASE sParaMod == "GEDCOM"
      aw_ged()
   CASE sParaMod == "FSTAND"
      aw_fstan()
   CASE sParaMod == "FIND"
      aw_find()
   CASE sParaMod == "PATEN"
      aw_paten()
   CASE sParaMod == "PERPAT"
      aw_ppat()
   CASE sParaMod == "TAUFREG"
      aw_treg()
   CASE sParaMod == "STERBEREG"
      aw_sreg()
   CASE sParaMod == "BEGRREGO"
      aw_brego()
   CASE sParaMod == "PER001"
      aw_001()
   CASE sParaMod == "STAT"
      aw_stat()
   OTHERWISE
      prog_ende(.F.)
   ENDCASE

   // ------------------------------------------------------------------------
   prog_ende()
   // ------------------------------------------------------------------------

RETURN
// ---------------------------------------------------------------------------





