// ---------------------------------------------------------------------------
// Ahnen-Stamm == Triviale Ad-Hoc Lsung zu Demonstrationszwecken
//
// Das kann man alles viel besser machen - aber :
//
//     1. kostet das Zeit
//     2. wird es fr den Einsteiger schwerer verstndlich
// ---------------------------------------------------------------------------

#include "std.ch"

// ---------------------------------------------------------------------------
PROCEDURE th639_3(sParaCol)
// ---------------------------------------------------------------------------
LOCAL sVer    := "1.0"

LOCAL iHdl    := 0
LOCAL iHdlPrn := 0
LOCAL aDbf    := {}
LOCAL sFile   := "GPDATA.DBF"
LOCAL sFileDBT:= "GPDATA.DBT"
LOCAL sFileIdx1:= "GPDATA1.NTX"
LOCAL sFileIdx2:= "GPDATA2.NTX"
LOCAL iFileSize

LOCAL fOk     := .F.

LOCAL sZeile  := ""
LOCAL iPer    := 0

LOCAL fPer, cLevel, cAltLevel, sTag
LOCAL sPer

LOCAL fGPFok
LOCAL iRec

LOCAL i,j

LOCAL sListTyp, iPNr, iKek, iMaxKek
// ---------------------------------------------------------------------------
   set_init()                             // Systemeinstellungen

   IF VALTYPE(sParaCol) == "C"            // Egal welcher Wert, immer SW
      std_color(.F.)
   ELSE
      std_color()                         // Dann erkenne mal schn selber ...
   ENDIF

   hauptmaske("GENPROFI Export                                                     Auswertungen", ;
              "Ahnenstamm                                                           Version : 1")
   // ------------------------------------------------------------------------
   // Hinweise auf aktuelles Programm-Modul
   // ------------------------------------------------------------------------
   SETCOLOR(MEMVAR->sColScr)
   @ 5,0  SAY "Modulversion"          ; @ 5,30 SAY sVer

   @ 7,0  SAY "Auswertungsdateigre"
   @ 8,0  SAY "Stand der Auswertung"

   @ 10,0 SAY "Anzahl Personen"

   @ 12,0 SAY "Anzahl Eintrge"
   @ 13,0 SAY "Stand der Ausgabe"

   BEGIN SEQUENCE                      // Dies ist sehr praktisch ...

   i := ALERT("Ausgabevariante", ;
              {"Mannesstamm", "Frauenstamm"})

   IF i = 1
      @ 4,0  SAY "Stamm : 1-2-4-8-..."
      sListTyp := "MSTAMM"
   ELSEIF i = 2
      @ 4,0  SAY "Stamm : 1-3-7-15-..."
      sListTyp := "FSTAMM"
   ELSE
      BREAK
   ENDIF

   i := ALERT("Ausgabeumfang", ;
              {"Kompakt", "bersicht"})

   IF i = 1
      @ 4,30  SAY "Kompaktausgabe"
      sListTyp += "/KOMP"
   ELSE
      @ 4,30  SAY "bersichtausgabe"
      sListTyp += "/UEB"
   ENDIF

   // ------------------------------------------------------------------------
   // Hilfsdatei erzeugen ...
   // ------------------------------------------------------------------------
   meldung("Vorbereitung Stammauswertung ... Bitte warten ...")

   FERASE(sFile)                       // eventuelle Reste entfernen

   aDbf  := {}
   AADD(aDbf, {"GENERAT"   ,"N",  2, 0})   // Generation
   AADD(aDbf, {"KEKULE"    ,"N", 16, 0})   // Ahnennummer
   AADD(aDbf, {"PNR"       ,"N", 10, 0})   // Personennummer
   AADD(aDbf, {"PERSON"    ,"M", 10, 0})   // Personendaten

   DBCREATE(sFile, aDbf)

   IF FILE(sFile)
      USE (sFile) ALIAS GPDATA EXCLUSIVE NEW
      IF NETERR()
         fehler("Hilfsdatei konnte nicht geffnet werden. Abbruch!")
         BREAK
      ENDIF
      INDEX ON STR(GPDATA->KEKULE,16) TO (sFileIdx1)
      INDEX ON STR(GPDATA->PNR, 10)   TO (sFileIdx2)

      SET INDEX TO (sFileIdx1), (sFileIdx2)
   ELSE
      fehler("Hilfsdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // Hilfsdatei mit den Ahnennummern des Stammes fllen ...
   // nicht elegant aber bersichtlich

   SELECT GPDATA

   IF "MSTAMM" $ sListTyp
      FOR i:= 0 TO 49                  // maximal 50 Generationen
         APPEND BLANK
         GPDATA->GENERAT := i
         GPDATA->KEKULE  := 2 ^ i
      NEXT
   ELSE
      FOR i:= 1 TO 50                  // maximal 50 Generationen
         APPEND BLANK
         GPDATA->GENERAT := i - 1      // Proband = Generation 0
         GPDATA->KEKULE  := 2 ^ i - 1  // Frauenstamm
      NEXT
   ENDIF

   // ------------------------------------------------------------------------
   // Exportdatei Numerierung ffnen ...
   // ------------------------------------------------------------------------
   IF ! FILE("EXPORT\GPEXP.GDL")
      fehler("Datei 'EXPORT\GPEXP.GDL' nicht vorhanden. Abbruch!")
      BREAK
   ENDIF

   iHdl := FOPEN("EXPORT\GPEXP.GDL")

   IF iHdl < 1
      fehler("Datei 'EXPORT\GPEXP.GDL' konnte nicht gffnet werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Einlesen der Numerierung und Belegung der Personennummern
   // ------------------------------------------------------------------------
   SET ORDER TO 1

   sZeile := ""
   DO WHILE FREADLINE(iHdl, @sZeile)

      IF ! "," $ sZeile                // kein Ahnenschwund
         iPNr := VAL(SUBS(sZeile, 1, AT("=", sZeile)-1))
         iKek := VAL(SUBS(sZeile, AT("=", sZeile)+1))

         SEEK STR(iKek, 16)

         IF FOUND()
            GPDATA->PNR := iPNr
         ENDIF
      ENDIF
   ENDDO

   FCLOSE(iHdl)                        // Numerierungsdatei wieder schlieen

   // ------------------------------------------------------------------------
   // Alle undefinierten Stze rausschmeien
   // ------------------------------------------------------------------------
   SELECT GPDATA
   DELETE ALL FOR EMPTY(GPDATA->PNR)
   PACK
   // ------------------------------------------------------------------------

   // ------------------------------------------------------------------------
   // Exportdatei ffnen ...
   // ------------------------------------------------------------------------
   IF ! FILE("EXPORT\GPEXP.GDF")
      fehler("Datei 'EXPORT\GPEXP.GDF' nicht vorhanden. Abbruch!")
      BREAK
   ENDIF

   iHdl := FOPEN("EXPORT\GPEXP.GDF")

   IF iHdl < 1
      fehler("Datei 'EXPORT\GPEXP.GDF' konnte nicht gffnet werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Dateigre ermitteln ...
   // ------------------------------------------------------------------------
   iFileSize := FSEEK(iHdl, 0, 2)  ; FSEEK(iHdl, 0, 0)
   @ 7,30 SAY STR(iFileSize, 15, 0)

   // ------------------------------------------------------------------------
   // Druckdatei erzeugen ...
   // ------------------------------------------------------------------------
   iHdlPrn := FCREATE("GPDATA.PRN")

   IF iHdlPrn < 1
      fehler("Druckdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Einlesen der Daten ...
   // ------------------------------------------------------------------------
   meldung("Analyse Exportdatei ... Bitte warten ...")

   SELECT GPDATA
   SET ORDER TO 2

   fPer     := .F.
   sTag     := ""
   sPer     := ""
   iPNr     := 0

   fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

   DO WHILE fGPFok

      IF cLevel == "0"                 // Hauptsatz

         // ------------------------------------------------------------------
         // Umsetzen der bisherigen Werte ...
         // ------------------------------------------------------------------
         IF ! EMPTY(sPer) .AND. ;
            ! EMPTY(iPnr)

            SELECT GPDATA
            SEEK STR(iPnr, 10)

            IF FOUND()
               GPDATA->PERSON := sPer
            ENDIF
         ENDIF

         // ------------------------------------------------------------------
         // Zurcksetzen der Zwischenspeicher
         // ------------------------------------------------------------------
         sPer     := ""
         iPnr     := 0

         IF sTag == "TRLR"             // Dateiende
            EXIT
         ELSEIF sTag == "INDI"         // Personen
            fPer := .T.
            iPer++

            iPnr := VAL(SUBS(sZeile, 2))     // I1, ...

         ELSE                          // Ignorieren
            fPer := .F.
         ENDIF
         fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
      ELSE
         IF fPer                       // nur Personen analysieren
            IF sTag == "GP.DAR.KOMP"
               IF "/KOMP" $ sListTyp
                  sPer := sZeile
               ENDIF
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.DAR.UEB"
               IF "/UEB" $ sListTyp
                  sPer := sZeile
               ENDIF
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSE                                 // nchste Zeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ENDIF
         ELSE
            fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
         ENDIF
      ENDIF

      @  8,30 SAY STR(FSEEK(iHdl,0,1)/iFileSize * 100, 14) + "%"
      @ 10,30 SAY STR(iPer, 15, 0)
      @ 12,30 SAY STR(GPDATA->(LASTREC()), 15, 0)

      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF
   ENDDO
   @  8,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Ausdruck ...
   // ---------------------------------------------------------------------------
   SELECT GPDATA
   SET ORDER TO 1
   GO BOTTOM
   iMaxKek := LEN(ALLTRIM(STR(GPDATA->KEKULE, 16)))      // max. Lnge

   GO TOP

   iRec := 1

   IF ! FWRITELINE(iHdlPrn, "#ABS_LR=0")   ; BREAK ; ENDIF
   IF ! FWRITELINE(iHdlPrn, "#ABS_LRFL=" + ISTR(iMaxKek+1)) ; BREAK ; ENDIF

   DO WHILE ! GPDATA->(EOF())

      // "#SATZNR" gibt die lfd. Nummer an.
      // Auf diese Angabe knnte verzichtet werden, aber so ist die
      // Ausgabe vollstndig.
      IF ! FWRITELINE(iHdlPrn, "#SATZNR="+ISTR(iRec)) ; BREAK ; ENDIF

      sZeile := "^A" + PADR(ISTR(GPDATA->KEKULE), iMaxKek) + "^B ^#" + ;
                IF(EMPTY(GPDATA->PERSON), "n.n", GPDATA->PERSON)


      IF ! FWRITELINE(iHdlPrn, sZeile) ; BREAK ; ENDIF
      IF ! FWRITELINE(iHdlPrn, "")     ; BREAK ; ENDIF

      IF INKEY() == 27 ; BREAK ; ENDIF
      iRec ++
      @ 13,30 SAY STR(iRec/GPDATA->(LASTREC()) * 100, 14) + "%"
      SKIP
   ENDDO

   IF ! FWRITELINE(iHdlPrn, "") ; BREAK ; ENDIF
   @ 13,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Erzeugen der Definitionsdatei fr den Ausdruck ber GP_PRN FASC
   // ---------------------------------------------------------------------------
   STRFILE("FRM=2"                   + CRLF + ;
           "VER=" + sVer            + CRLF + ;
           "TITEL=Ahnenstamm"  + CRLF + ;
           "Z=92"                   + CRLF,  ;
           "GPDATA.DEF")

   fOk := .T.                          // Alles ist durchgelaufen

   END SEQUENCE

   // ---------------------------------------------------------------------------
   // Aufrumen
   // ---------------------------------------------------------------------------

   CLOSE ALL                           // Alle Datenbanken werden geschlossen

   FERASE(sFile)                       // Hilfsdatei wird nicht mehr bentigt
   FERASE(sFileDBT)
   FERASE(sFileIdx1)
   FERASE(sFileIdx2)
   FCLOSE(iHdl)
   FCLOSE(iHdlPrn)

   SETCOLOR(MEMVAR->sColScr)           // Bildschirm wieder aufrumen
   @ 4,0 CLEAR TO 22,79

   IF ! fOk                            // Abbruch oder Fehler
      // Dann mssen eventuelle Reste der Druckdateien entfernt werden!
      FERASE("GPDATA.DEF")
      FERASE("GPDATA.PRN")
   ENDIF

   prog_ende()

RETURN
// ---------------------------------------------------------------------------
