/* Lschen, ohne zu fragen ... */

#include <dos.h>    /* needed for _dos functions */
#include <malloc.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>  /* needed for _splitpath and pathname constants */

main (int argc, char *argv[]) {
    int result;
    struct find_t fileinfo;
    char response,
         drive[_MAX_DRIVE],
         directory[_MAX_DIR],
         filename[_MAX_FNAME],
         extension[_MAX_EXT];
    char *fullfilename;

    if (argc >= 2) {
       result = _dos_findfirst(argv[1], 0, &fileinfo);

       if (result != 0)
          printf("!DEL %s\n", argv[1]);
       else {
          _splitpath(argv[1], drive, directory, filename, extension);

          while (!result) { /* expand wildcards */

            if (fullfilename = (char *) malloc (_MAX_DIR+13) ) {

               strcpy(fullfilename, drive);
               strcat(fullfilename, directory);
               strcat(fullfilename, fileinfo.name);

               /* ev. READ ONLY aufheben */
               _dos_setfileattr(fullfilename, _A_NORMAL);

               if (remove(fullfilename))
                  printf("-DEL %s\n", strlwr(fullfilename));
               else
                  printf("+DEL %s\n", strlwr(fullfilename));

               free(fullfilename);
            }
            result = _dos_findnext(&fileinfo);
          }
       }
    }
}
