/* SBT, Heiko Thimm

/* Steuerung ber Parameter                                      */
/* M  -  Erstellen von Unterverzeichnissen                       */
/*       Ersatz von MD unter DOS, da existierende Verzeichnisse  */
/*       immer mit Fehlermeldung belegt werden.                  */
/* R  -  Entfernen von Unterverzeichnissen                       */

#include <dos.h>    /* needed for _dos functions */
#include <malloc.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>  /* needed for _splitpath and pathname constants */

main (int argc, char *argv[])
{
   char *typ1 = "M",
        *typ2 = "R";

   int status;

   if (argc == 3)      // test number of arguments
   {
      if ((strcmp(strupr(argv[1]),typ1) != 0) &&
	  (strcmp(strupr(argv[1]),typ2) != 0))
          exit(-1);

      if (strcmp(strupr(argv[1]),typ1) == 0)       // Erzeugen von Directories
      {
	 if (! mkdir(argv[2]))
         {
            printf("+DIR %s\n",
		    strlwr(argv[2]));
            exit(0);
         }
         else
            exit(1);
      }

      if (strcmp(strupr(argv[1]),typ2) == 0)       // Entfernen von Directories
      {
	 if (! rmdir(argv[2]))
         {
            printf("-DIR %s\n",
		    strlwr(argv[2]));
            exit(0);
         }
         else
            exit(1);
      }

   }
}
